Could bundler & rubygems be shipped in site_ruby?

02/18/2019 03:11 PM - deivid (David Rodríguez)

Status: Rejected   

Priority: Normal   

Assignee: hsbt (Hiroshi SHIBATA)   

Description

Currently bundler & rubygems are shipped together with the rest of the standard library (in RbConfig::CONFIG["rubylibdir"]). The fact

that they share their folder with the rest of the standard library has caused some issues that wouldn't have happened if they were

isolated. For example, https://bugs.ruby-lang.org/issues/15469 or https://github.com/rubygems/rubygems/issues/2188.

Also, when you run gem update --system, rubygems installs a copy of itself and bundler in site_ruby, so you currently end up with

two copies of different versions of bundler and rubygems in different folders of the $LOAD_PATH.

@hsbt (Hiroshi SHIBATA) has fixed the above issues with a patch to bundler in https://github.com/bundler/bundler/pull/6941, but I

still wonder whether it could be cleaner to ship them in site_ruby directly, so that gem update --system overwrites them and you

always have a single default copy of both rubygems and bundler.

Maybe this wouldn't be a good usage of site_ruby, and it's better to keep things as they are, but I figured I could ask ruby-core about

it.

Thanks for what you do!

Related issues:

Related to Ruby - Feature #15611: Shipping Bundler as a bundled gem, not a de... Rejected

History

#1 - 02/18/2019 03:29 PM - shevegen (Robert A. Heiler)

I can not answer the question, as I think that is up to the ruby core team, Hiroshi,

the gem-team and the bundler team. However had perhaps it may be worthwhile to actually

consider a new unified name? Perhaps for ruby 3.0 or if that is too early, ruby

4.0. And consider one unified application (e. g. both bundler and rubygems).

People could still decide on their own which functionality they would want to

use (and I mean this in the sense of retaining all the functionality that currently

exists). Although this may be too early ... I thought I would mention it at the

least once.

This could also be discussed at an upcoming developer meeting - not solely the

issue here alone, but long term goals and integration. If I recall correctly,

drbrain years ago said that one reason for a merge of bundler + gem would

be so to avoid code duplication (that was years before the work by Hiroshi

and others).

#2 - 02/18/2019 06:35 PM - Eregon (Benoit Daloze)

- Related to Feature #15611: Shipping Bundler as a bundled gem, not a default gem added

#3 - 02/18/2019 06:36 PM - Eregon (Benoit Daloze)

@deivid I have another proposal in https://bugs.ruby-lang.org/issues/15611, what do you think?

#4 - 02/18/2019 11:53 PM - hsbt (Hiroshi SHIBATA)

- Status changed from Open to Assigned

- Assignee set to hsbt (Hiroshi SHIBATA)

#5 - 03/08/2019 11:54 AM - hsbt (Hiroshi SHIBATA)

- Status changed from Assigned to Rejected

See https://bugs.ruby-lang.org/issues/15611#note-7

#6 - 03/22/2019 03:32 PM - vo.x (Vit Ondruch)
https://bugs.ruby-lang.org/issues/15469
https://github.com/rubygems/rubygems/issues/2188
https://redmine.ruby-lang.org/users/572
https://github.com/bundler/bundler/pull/6941
https://bugs.ruby-lang.org/issues/15611
https://bugs.ruby-lang.org/issues/15611#note-7


Just for completeness, this is my proposal:

https://bugs.ruby-lang.org/issues/5617

Powered by TCPDF (www.tcpdf.org)

05/26/2025 2/2

https://bugs.ruby-lang.org/issues/5617
http://www.tcpdf.org

